#ifndef ELM_SYS_NOTIFY_DBUS_EO_HH
#define ELM_SYS_NOTIFY_DBUS_EO_HH
#include <Eo.h>

extern "C" {
#include "elm_sys_notify_dbus.eo.h"
#include "elm_sys_notify_interface.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "elm_sys_notify_interface.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace sys_notify { 
struct Dbus;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::sys_notify::Dbus> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace sys_notify { 
struct Dbus {
   static Eo_Class const* _eo_class()
   {
      return ELM_SYS_NOTIFY_DBUS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::sys_notify::Dbus() const;
   operator ::elm::sys_notify::Dbus&();
   operator ::elm::sys_notify::Dbus const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Dbus,  ::elm::Sys_Notify_Interface,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Dbus const ,  ::elm::Sys_Notify_Interface const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace sys_notify { 
struct Dbus : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::elm::Sys_Notify_Interface)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Dbus( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Dbus(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Dbus(Dbus const& other) = default;
   Dbus(Dbus&& other) = default;
   Dbus& operator=(Dbus const& other) = default;
   Dbus& operator=(Dbus&& other) = default;
   Dbus()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Dbus( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Dbus(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return ELM_SYS_NOTIFY_DBUS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Dbus,  ::elm::Sys_Notify_Interface,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Dbus const ,  ::elm::Sys_Notify_Interface const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Dbus) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Dbus>::value, "");
} } 
#include "elm_sys_notify_dbus.eo.impl.hh"
#endif
